Index: codes/icosagcm/trunk/param_sets/dcmip2012/const.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/const.def	(revision 284)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/const.def	(revision 284)
@@ -0,0 +1,33 @@
+
+#---------------- Planet ----------------
+
+# Planetary radius : real (default=6371220)
+radius = 6.37122e6
+
+# Gravity : real (default=9.80616)
+g = 9.80616
+
+# kappa=Rd/cpp : real (default=0.2857143)
+kappa = 0.2857143
+
+# Heat capacity at constant pressure : real (default=1004.70885)
+cpp = 1004.5
+
+# Reference pressure : real (default=101325)
+preff = 1e5
+
+# Planetary rotation rate : real (default=7.292E-5)
+omega = 7.292e-5
+
+
+#---------------- Constants ----------------
+
+# Reference temperature T0 for DCMIP test cases : real (default=300)
+ncar_T0 = 300
+
+# Reference pressure p0 for DCMIP test cases, used by disvert if disver=ncar : real (default=1e5)
+ncar_p0 = 1e5
+
+# Exponent for B(eta), used by disvert if disvert=ncar : integer (default=1)
+ncar_disvert_c = 1
+
Index: codes/icosagcm/trunk/param_sets/dcmip2012/run11.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/run11.def	(revision 284)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/run11.def	(revision 284)
@@ -0,0 +1,93 @@
+
+#---------------- Planet ----------------
+
+# Planetary radius : real (default=6371220)
+radius = 6.37122e6
+
+# Gravity : real (default=9.80616)
+g = 9.80616
+
+# kappa=Rd/cpp : real (default=0.2857143)
+kappa = 0.2857143
+
+# Heat capacity at constant pressure : real (default=1004.70885)
+cpp = 1004.5
+
+# Reference pressure : real (default=101325)
+preff = 1e5
+
+# Planetary rotation rate : real (default=7.292E-5)
+omega = 0
+
+
+#---------------- Constants ----------------
+
+# Reference temperature T0 for DCMIP test cases : real (default=300)
+ncar_T0 = 300
+
+# Reference pressure p0 for DCMIP test cases, used by disvert if disver=ncar : real (default=1e5)
+ncar_p0 = 1e5
+
+# Exponent for B(eta), used by disvert if disvert=ncar : integer (default=1)
+ncar_disvert_c = 1
+
+
+#---------------- Mesh ----------------
+
+# Number of subdivisions on a main triangle : integer (default=40)
+nbp = 80
+
+# Number of vertical layers : integer (default=19)
+llm = 60
+
+# Vertical grid : [std|ncar|ncarl30] (default=std)
+disvert = ncar
+
+# Model layer thickness in m, used if disvert=ncar : real (default=300)
+ncar_dz = 200
+
+# Mesh optimisation : number of iterations : integer (default=0)
+optim_it = 100
+
+# Sub splitting of main rhombus : integer (default=1)
+nsplit_i = 2
+nsplit_j = 2
+
+
+#---------------- Numerics ----------------
+
+# Equations solved : [gcm|adv] (default=gcm)
+caldyn = adv
+
+# Time step in s : real (default=480)
+dt = 180
+
+
+#---------------- Time ----------------
+
+# Run length in s : real (default=??)
+run_length = 1036800
+
+# Interval in s between two outputs : integer (default=??)
+write_period = 86400
+
+
+#---------------- Physical parameters ----------------
+
+# Number of tracers : integer (default=1)
+nqtot = 5
+
+# Type of guiding terms : [none|dcmip1] (default=none)
+guided_type = dcmip1
+
+# Initial state : 
+#   [jablonowsky06|academic|dcmip[1-4]|heldsz|dcmip2_schaer_noshear] (default=jablonowsky06)
+etat0 = dcmip1
+
+# DCMIP 1.1 advection test, initial tracer field : 
+#    [const|slotted_cyl|cos_bell|dbl_cos_bell_q1|dbl_cos_bell_q2|complement|hadley|dcmip11] (default=cos_bell)
+dcmip1_shape = dcmip11
+
+# DCMIP 1.1 advection test, wind field : [solid|deform|hadley] (default=deform)
+dcmip1_wind = deform
+
Index: codes/icosagcm/trunk/param_sets/dcmip2012/run20.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/run20.def	(revision 284)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/run20.def	(revision 284)
@@ -0,0 +1,98 @@
+
+#---------------- Planet ----------------
+
+# Planetary radius : real (default=6371220)
+radius = 6.37122e6
+
+# Gravity : real (default=9.80616)
+g = 9.80616
+
+# kappa=Rd/cpp : real (default=0.2857143)
+kappa = 0.2857143
+
+# Heat capacity at constant pressure : real (default=1004.70885)
+cpp = 1004.5
+
+# Reference pressure : real (default=101325)
+preff = 1e5
+
+# Planetary rotation rate : real (default=7.292E-5)
+omega = 0
+
+
+#---------------- Constants ----------------
+
+# Reference temperature T0 for DCMIP test cases : real (default=300)
+ncar_T0 = 300
+
+# Reference pressure p0 for DCMIP test cases, used by disvert if disver=ncar : real (default=1e5)
+ncar_p0 = 1e5
+
+# Exponent for B(eta), used by disvert if disvert=ncar : integer (default=1)
+ncar_disvert_c = 1
+
+
+#---------------- Mesh ----------------
+
+# Number of subdivisions on a main triangle : integer (default=40)
+nbp = 64
+
+# Number of vertical layers : integer (default=19)
+llm = 15
+
+# Vertical grid : [std|ncar|ncarl30] (default=std)
+disvert = ncar
+
+# Model layer thickness in m, used if disvert=ncar : real (default=300)
+ncar_dz = 800
+
+# Mesh optimisation : number of iterations : integer (default=0)
+optim_it = 100
+
+# Sub splitting of main rhombus : integer (default=1)
+nsplit_i = 2
+nsplit_j = 2
+
+
+#---------------- Numerics ----------------
+
+# Time step in s : real (default=480)
+dt = 300
+
+# Dissipation time for grad(div) : real (default=5000)
+tau_graddiv = 10800
+
+# Exponent of grad(div) disspation : integer (default=1)
+nitergdiv = 2
+
+# Dissipation time for curl(curl) : real (default=5000)
+tau_gradrot = 10800
+
+# Exponent of curl(curl) disspation : integer (default=1)
+nitergrot = 2
+
+# Dissipation time for div(grad) : real (default=5000)
+tau_divgrad = 10800
+
+# Exponent of div(grad) disspation : integer (default=1)
+niterdivgrad = 2
+
+
+#---------------- Time ----------------
+
+# Run length in s : real (default=??)
+run_length = 518400
+
+# Interval in s between two outputs : integer (default=??)
+write_period = 21600
+
+
+#---------------- Physical parameters ----------------
+
+# Scale factor for small planet experiment : real (default=1.)
+scale_factor = 1
+
+# Initial state : 
+#   [jablonowsky06|academic|dcmip[1-4]|heldsz|dcmip2_schaer_noshear] (default=jablonowsky06)
+etat0 = dcmip2_mountain
+
Index: codes/icosagcm/trunk/param_sets/dcmip2012/run21.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/run21.def	(revision 284)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/run21.def	(revision 284)
@@ -0,0 +1,104 @@
+
+#---------------- Planet ----------------
+
+# Planetary radius : real (default=6371220)
+radius = 6.37122e6
+
+# Gravity : real (default=9.80616)
+g = 9.80616
+
+# kappa=Rd/cpp : real (default=0.2857143)
+kappa = 0.2857143
+
+# Heat capacity at constant pressure : real (default=1004.70885)
+cpp = 1004.5
+
+# Reference pressure : real (default=101325)
+preff = 1e5
+
+# Planetary rotation rate : real (default=7.292E-5)
+omega = 0
+
+
+#---------------- Constants ----------------
+
+# Reference temperature T0 for DCMIP test cases : real (default=300)
+ncar_T0 = 300
+
+# Reference pressure p0 for DCMIP test cases, used by disvert if disver=ncar : real (default=1e5)
+ncar_p0 = 1e5
+
+# Exponent for B(eta), used by disvert if disvert=ncar : integer (default=1)
+ncar_disvert_c = 1
+
+
+#---------------- Mesh ----------------
+
+# Number of subdivisions on a main triangle : integer (default=40)
+nbp = 64
+
+# Number of vertical layers : integer (default=19)
+llm = 60
+
+# Vertical grid : [std|ncar|ncarl30] (default=std)
+disvert = ncar
+
+# Model layer thickness in m, used if disvert=ncar : real (default=300)
+ncar_dz = 500
+
+# Mesh optimisation : number of iterations : integer (default=0)
+optim_it = 100
+
+# Sub splitting of main rhombus : integer (default=1)
+nsplit_i = 2
+nsplit_j = 2
+
+
+#---------------- Numerics ----------------
+
+# Time step in s : real (default=480)
+dt = 300
+
+# Dissipation time for grad(div) : real (default=5000)
+tau_graddiv = 10800
+
+# Exponent of grad(div) disspation : integer (default=1)
+nitergdiv = 2
+
+# Dissipation time for curl(curl) : real (default=5000)
+tau_gradrot = 10800
+
+# Exponent of curl(curl) disspation : integer (default=1)
+nitergrot = 2
+
+# Dissipation time for div(grad) : real (default=5000)
+tau_divgrad = 10800
+
+# Exponent of div(grad) disspation : integer (default=1)
+niterdivgrad = 2
+
+
+#---------------- Time ----------------
+
+# Run length in s : real (default=??)
+run_length = 3.6e6
+
+# Interval in s between two outputs : integer (default=??)
+write_period = 50000
+
+
+#---------------- Physical parameters ----------------
+
+# Scale factor for small planet experiment : real (default=1.)
+scale_factor = 500
+
+# Initial state : 
+#   [jablonowsky06|academic|dcmip[1-4]|heldsz|dcmip2_schaer_noshear] (default=jablonowsky06)
+etat0 = dcmip2_schaer_noshear
+
+# Relaxation time for Rayleigh friction : 0 (default=none)
+rayleigh_friction_tau = 12500
+
+# Type of Rayleigh friction : [none|dcmip21] (default=none)
+rayleigh_friction_type = dcmip2_schaer_noshear
+
Index: codes/icosagcm/trunk/param_sets/dcmip2012/run3.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/run3.def	(revision 284)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/run3.def	(revision 284)
@@ -0,0 +1,98 @@
+
+#---------------- Planet ----------------
+
+# Planetary radius : real (default=6371220)
+radius = 6.37122e6
+
+# Gravity : real (default=9.80616)
+g = 9.80616
+
+# kappa=Rd/cpp : real (default=0.2857143)
+kappa = 0.2857143
+
+# Heat capacity at constant pressure : real (default=1004.70885)
+cpp = 1004.5
+
+# Reference pressure : real (default=101325)
+preff = 1e5
+
+# Planetary rotation rate : real (default=7.292E-5)
+omega = 0
+
+
+#---------------- Constants ----------------
+
+# Reference temperature T0 for DCMIP test cases : real (default=300)
+ncar_T0 = 300
+
+# Reference pressure p0 for DCMIP test cases, used by disvert if disver=ncar : real (default=1e5)
+ncar_p0 = 1e5
+
+# Exponent for B(eta), used by disvert if disvert=ncar : integer (default=1)
+ncar_disvert_c = 1
+
+
+#---------------- Mesh ----------------
+
+# Number of subdivisions on a main triangle : integer (default=40)
+nbp = 80
+
+# Number of vertical layers : integer (default=19)
+llm = 10
+
+# Vertical grid : [std|ncar|ncarl30] (default=std)
+disvert = ncar
+
+# Model layer thickness in m, used if disvert=ncar : real (default=300)
+ncar_dz = 1000
+
+# Mesh optimisation : number of iterations : integer (default=0)
+optim_it = 100
+
+# Sub splitting of main rhombus : integer (default=1)
+nsplit_i = 2
+nsplit_j = 2
+
+
+#---------------- Numerics ----------------
+
+# Time step in s : real (default=480)
+dt = 240
+
+# Dissipation time for grad(div) : real (default=5000)
+tau_graddiv = 9000
+
+# Exponent of grad(div) disspation : integer (default=1)
+nitergdiv = 2
+
+# Dissipation time for curl(curl) : real (default=5000)
+tau_gradrot = 9000
+
+# Exponent of curl(curl) disspation : integer (default=1)
+nitergrot = 2
+
+# Dissipation time for div(grad) : real (default=5000)
+tau_divgrad = 9000
+
+# Exponent of div(grad) disspation : integer (default=1)
+niterdivgrad = 2
+
+
+#---------------- Time ----------------
+
+# Run length in s : real (default=??)
+run_length = 4.5e5
+
+# Interval in s between two outputs : integer (default=??)
+write_period = 12500
+
+
+#---------------- Physical parameters ----------------
+
+# Scale factor for small planet experiment : real (default=1.)
+scale_factor = 125
+
+# Initial state : 
+#   [jablonowsky06|academic|dcmip[1-4]|heldsz|dcmip2_schaer_noshear] (default=jablonowsky06)
+etat0 = dcmip3
+
Index: codes/icosagcm/trunk/param_sets/dcmip2012/run41.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/run41.def	(revision 284)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/run41.def	(revision 284)
@@ -0,0 +1,66 @@
+INCLUDEDEF = const.def
+
+#---------------- Mesh ----------------
+
+# Number of subdivisions on a main triangle : integer (default=40)
+nbp = 80
+
+# Number of vertical layers : integer (default=19)
+llm = 30
+
+# Vertical grid : [std|ncar|ncarl30] (default=std)
+disvert = ncarl30
+
+# Mesh optimisation : number of iterations : integer (default=0)
+optim_it = 100
+
+# Sub splitting of main rhombus : integer (default=1)
+nsplit_i = 2
+nsplit_j = 2
+
+
+#---------------- Numerics ----------------
+
+# Time step in s : real (default=480)
+dt = 240
+
+# Dissipation time for grad(div) : real (default=5000)
+tau_graddiv = 9000
+
+# Exponent of grad(div) disspation : integer (default=1)
+nitergdiv = 2
+
+# Dissipation time for curl(curl) : real (default=5000)
+tau_gradrot = 9000
+
+# Exponent of curl(curl) disspation : integer (default=1)
+nitergrot = 2
+
+# Dissipation time for div(grad) : real (default=5000)
+tau_divgrad = 9000
+
+# Exponent of div(grad) disspation : integer (default=1)
+niterdivgrad = 2
+
+
+#---------------- Time ----------------
+
+# Run length in s : real (default=??)
+run_length = 3.6e6
+
+# Interval in s between two outputs : integer (default=??)
+write_period = 21600
+
+
+#---------------- Physical parameters ----------------
+
+# Number of tracers : integer (default=1)
+nqtot = 2
+
+# Initial state : 
+#   [jablonowsky06|academic|dcmip[1-4]|heldsz|dcmip2_schaer_noshear] (default=jablonowsky06)
+etat0 = dcmip4
+
+# DCMIP 4 Test case : [1|2] (default=1)
+dcmip4_testcase = 1
+
Index: codes/icosagcm/trunk/param_sets/dcmip2012/run42.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/run42.def	(revision 284)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/run42.def	(revision 284)
@@ -0,0 +1,72 @@
+INCLUDEDEF = const.def
+
+#---------------- Mesh ----------------
+
+# Number of subdivisions on a main triangle : integer (default=40)
+nbp = 80
+
+# Number of vertical layers : integer (default=19)
+llm = 30
+
+# Vertical grid : [std|ncar|ncarl30] (default=std)
+disvert = ncarl30
+
+# Mesh optimisation : number of iterations : integer (default=0)
+optim_it = 100
+
+# Sub splitting of main rhombus : integer (default=1)
+nsplit_i = 2
+nsplit_j = 2
+
+
+#---------------- Numerics ----------------
+
+# Time step in s : real (default=480)
+dt = 240
+
+# Dissipation time for grad(div) : real (default=5000)
+tau_graddiv = 9000
+
+# Exponent of grad(div) disspation : integer (default=1)
+nitergdiv = 2
+
+# Dissipation time for curl(curl) : real (default=5000)
+tau_gradrot = 9000
+
+# Exponent of curl(curl) disspation : integer (default=1)
+nitergrot = 2
+
+# Dissipation time for div(grad) : real (default=5000)
+tau_divgrad = 9000
+
+# Exponent of div(grad) disspation : integer (default=1)
+niterdivgrad = 2
+
+
+#---------------- Time ----------------
+
+# Run length in s : real (default=??)
+run_length = 3.6e6
+
+# Interval in s between two outputs : integer (default=??)
+write_period = 21600
+
+
+#---------------- Physical parameters ----------------
+
+# Number of tracers : integer (default=1)
+nqtot = 2
+
+# Initial state : 
+#   [jablonowsky06|academic|dcmip[1-4]|heldsz|dcmip2_schaer_noshear] (default=jablonowsky06)
+etat0 = dcmip4
+
+# DCMIP 4 Test case : [1|2] (default=1)
+dcmip4_testcase = 2
+
+# Physics package : [none|held_suarez|dcmip] (default=none)
+physics = dcmip
+
+# DCMIP physics : [0|1] (default=1)
+dcmip_physics = 1
+
Index: codes/icosagcm/trunk/param_sets/dcmip2012/run51.def
===================================================================
--- codes/icosagcm/trunk/param_sets/dcmip2012/run51.def	(revision 284)
+++ codes/icosagcm/trunk/param_sets/dcmip2012/run51.def	(revision 284)
@@ -0,0 +1,72 @@
+INCLUDEDEF = const.def
+
+#---------------- Mesh ----------------
+
+# Number of subdivisions on a main triangle : integer (default=40)
+nbp = 64
+
+# Number of vertical layers : integer (default=19)
+llm = 30
+
+# Vertical grid : [std|ncar|ncarl30] (default=std)
+disvert = ncarl30
+
+# Mesh optimisation : number of iterations : integer (default=0)
+optim_it = 1000
+
+# Sub splitting of main rhombus : integer (default=1)
+nsplit_i = 2
+nsplit_j = 2
+
+
+#---------------- Numerics ----------------
+
+# Time step in s : real (default=480)
+dt = 300
+
+# Dissipation time for grad(div) : real (default=5000)
+tau_graddiv = 10800
+
+# Exponent of grad(div) disspation : integer (default=1)
+nitergdiv = 2
+
+# Dissipation time for curl(curl) : real (default=5000)
+tau_gradrot = 10800
+
+# Exponent of curl(curl) disspation : integer (default=1)
+nitergrot = 2
+
+# Dissipation time for div(grad) : real (default=5000)
+tau_divgrad = 10800
+
+# Exponent of div(grad) disspation : integer (default=1)
+niterdivgrad = 2
+
+
+#---------------- Time ----------------
+
+# Run length in s : real (default=??)
+run_length = 864000
+
+# Interval in s between two outputs : integer (default=??)
+write_period = 7200
+
+
+#---------------- Physical parameters ----------------
+
+# Number of tracers : integer (default=1)
+nqtot = 1
+
+# Initial state : 
+#   [jablonowsky06|academic|dcmip[1-4]|heldsz|dcmip2_schaer_noshear] (default=jablonowsky06)
+etat0 = dcmip5
+
+# Physics package : [none|held_suarez|dcmip] (default=none)
+physics = dcmip
+
+# DCMIP physics : [0|1] (default=1)
+dcmip_physics = 0
+
+# Call physics every itau_physics time steps : integer (default=1)
+itau_physics = 6
+