Index: /codes/icosagcm/branches/SATURN_DYNAMICO/CONFIG/arch/arch-X64_ADA.path
===================================================================
--- /codes/icosagcm/branches/SATURN_DYNAMICO/CONFIG/arch/arch-X64_ADA.path	(revision 337)
+++ /codes/icosagcm/branches/SATURN_DYNAMICO/CONFIG/arch/arch-X64_ADA.path	(revision 338)
@@ -11,9 +11,9 @@
 #HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -lcurl"
 
-XIOS_INCDIR="-I$WORKDIR/SATURN_DYNAMICO/XIOS/inc"
-XIOS_LIBDIR="-L$WORKDIR/SATURN_DYNAMICO/XIOS/lib"
+XIOS_INCDIR="-I../../XIOS/inc"
+XIOS_LIBDIR="-L../../XIOS/lib"
 XIOS_LIB="-lxios -lstdc++"
 
 PHYSICS_INCDIR=""
-PHYSICS_LIBDIR="-L$WORKDIR/SATURN_DYNAMICO/LMDZ.COMMON/lib"
+PHYSICS_LIBDIR="-L../../LMDZ.COMMON/lib"
 PHYSICS_LIB="-llmdz"
Index: /codes/icosagcm/branches/SATURN_DYNAMICO/CONFIG/arch/arch-X64_CURIE.path
===================================================================
--- /codes/icosagcm/branches/SATURN_DYNAMICO/CONFIG/arch/arch-X64_CURIE.path	(revision 337)
+++ /codes/icosagcm/branches/SATURN_DYNAMICO/CONFIG/arch/arch-X64_CURIE.path	(revision 338)
@@ -11,9 +11,9 @@
 HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -lcurl"
 
-XIOS_INCDIR="-I$WORKDIR/SATURN_DYNAMICO/XIOS/inc"
-XIOS_LIBDIR="-L$WORKDIR/SATURN_DYNAMICO/XIOS/lib"
+XIOS_INCDIR="-I../../XIOS/inc"
+XIOS_LIBDIR="-L../../XIOS/lib"
 XIOS_LIB="-lxios -lstdc++"
 
 PHYSICS_INCDIR=""
-PHYSICS_LIBDIR="-L$WORKDIR/SATURN_DYNAMICO/LMDZ.COMMON/lib"
+PHYSICS_LIBDIR="-L../../LMDZ.COMMON/lib"
 PHYSICS_LIB="-llmdz"
Index: /codes/icosagcm/branches/SATURN_DYNAMICO/CONFIG/arch/arch-X64_OCCIGEN.env
===================================================================
--- /codes/icosagcm/branches/SATURN_DYNAMICO/CONFIG/arch/arch-X64_OCCIGEN.env	(revision 337)
+++ /codes/icosagcm/branches/SATURN_DYNAMICO/CONFIG/arch/arch-X64_OCCIGEN.env	(revision 338)
@@ -1,4 +1,4 @@
 #!/bin/bash
-module unload netcdf hdf5 intel bullxmpi
+module unload netcdf hdf5 intel bullxmpi intelmpi
 
 module load intel/14.0.4.211
@@ -10,4 +10,2 @@
 export HDF5_INC_DIR=$HDF5HOME/include
 export HDF5_LIB_DIR=$HDF5HOME/lib
-export NETCDF_INC_DIR="$PWD/../NETCDF4/include"
-export NETCDF_LIB_DIR="$PWD/../NETCDF4/lib"
Index: /codes/icosagcm/branches/SATURN_DYNAMICO/CONFIG/arch/arch-X64_OCCIGEN.path
===================================================================
--- /codes/icosagcm/branches/SATURN_DYNAMICO/CONFIG/arch/arch-X64_OCCIGEN.path	(revision 337)
+++ /codes/icosagcm/branches/SATURN_DYNAMICO/CONFIG/arch/arch-X64_OCCIGEN.path	(revision 338)
@@ -1,5 +1,5 @@
-NETCDF_INCDIR="-I$NETCDF_INC_DIR"
-NETCDF_LIBDIR="-L$NETCDF_LIB_DIR"
-NETCDF_LIB="-lnetcdff -lnetcdf "
+NETCDF_INCDIR="-I$NETCDFF_INCDIR -I$NETCDF_INC_DIR"
+NETCDF_LIBDIR="-L$NETCDFF_LIBDIR -L$NETCDF_LIB_DIR"
+NETCDF_LIB="-lnetcdff -lnetcdf"
 
 MPI_INCDIR=""
@@ -16,4 +16,4 @@
 
 PHYSICS_INCDIR=""
-PHYSICS_LIBDIR="-L$WORKDIR/SATURN_DYNAMICO/LMDZ.COMMON/lib"
+PHYSICS_LIBDIR="-L../../LMDZ.COMMON/lib"
 PHYSICS_LIB="-llmdz"
Index: /codes/icosagcm/branches/SATURN_DYNAMICO/CONFIG/arch/arch-X64_OCCIGEN_INTELMPI.env
===================================================================
--- /codes/icosagcm/branches/SATURN_DYNAMICO/CONFIG/arch/arch-X64_OCCIGEN_INTELMPI.env	(revision 337)
+++ /codes/icosagcm/branches/SATURN_DYNAMICO/CONFIG/arch/arch-X64_OCCIGEN_INTELMPI.env	(revision 338)
@@ -1,8 +1,8 @@
 #!/bin/bash
-module unload netcdf hdf5 intel bullxmpi
+module unload netcdf hdf5 intel bullxmpi intelmpi
 
 module load intel/14.0.4.211
-module load intelmpi  
-module load hdf5/1.8.14_parallel_intelmpi
+module load intelmpi/5.0.1.035   
+module load hdf5/1.8.14_parallel_intelmpi 
 module load netcdf/intelmpi/4.3.3-rc2
 module load netcdf/intelmpi/fortran-4.4.1_4.3.3-rc2
@@ -10,4 +10,2 @@
 export HDF5_INC_DIR=$HDF5HOME/include
 export HDF5_LIB_DIR=$HDF5HOME/lib
-export NETCDF_INC_DIR="$PWD/../NETCDF4/include"
-export NETCDF_LIB_DIR="$PWD/../NETCDF4/lib"
Index: /codes/icosagcm/branches/SATURN_DYNAMICO/CONFIG/arch/arch-X64_OCCIGEN_INTELMPI.path
===================================================================
--- /codes/icosagcm/branches/SATURN_DYNAMICO/CONFIG/arch/arch-X64_OCCIGEN_INTELMPI.path	(revision 337)
+++ /codes/icosagcm/branches/SATURN_DYNAMICO/CONFIG/arch/arch-X64_OCCIGEN_INTELMPI.path	(revision 338)
@@ -1,5 +1,5 @@
-NETCDF_INCDIR="-I$NETCDF_INC_DIR"
-NETCDF_LIBDIR="-L$NETCDF_LIB_DIR"
-NETCDF_LIB="-lnetcdff -lnetcdf "
+NETCDF_INCDIR="-I$NETCDFF_INCDIR -I$NETCDF_INC_DIR"
+NETCDF_LIBDIR="-L$NETCDFF_LIBDIR -L$NETCDF_LIB_DIR"
+NETCDF_LIB="-lnetcdff -lnetcdf"
 
 MPI_INCDIR=""
@@ -16,4 +16,4 @@
 
 PHYSICS_INCDIR=""
-PHYSICS_LIBDIR="-L$WORKDIR/SATURN_DYNAMICO/LMDZ.COMMON/lib"
+PHYSICS_LIBDIR="-L../../LMDZ.COMMON/lib"
 PHYSICS_LIB="-llmdz"
Index: des/icosagcm/branches/SATURN_DYNAMICO/CONFIG/compile_dynlmdz_occigen
===================================================================
--- /codes/icosagcm/branches/SATURN_DYNAMICO/CONFIG/compile_dynlmdz_occigen	(revision 337)
+++ 	(revision )
@@ -1,5 +1,0 @@
-cd ../LMDZ.COMMON
-./compile_occigen
-cd ../ICOSAGCM
-rm bin/icosa_gcm.exe
-./compile_occigen