Index: codes/icosagcm/devel/src/diagnostics/diagflux.f90
===================================================================
--- codes/icosagcm/devel/src/diagnostics/diagflux.f90	(revision 588)
+++ codes/icosagcm/devel/src/diagnostics/diagflux.f90	(revision 590)
@@ -20,5 +20,4 @@
        CALL zero_qfluxt
     ELSE
-       STOP ! FIXME
        CALL allocate_field(f_qfluxt,  field_u,type_real,llm,0, name="qfluxt")
        CALL allocate_field(f_qfluxt_lon,  field_t,type_real,llm,0, name="qfluxt_lon")
Index: codes/icosagcm/devel/src/transport/advect.F90
===================================================================
--- codes/icosagcm/devel/src/transport/advect.F90	(revision 588)
+++ codes/icosagcm/devel/src/transport/advect.F90	(revision 590)
@@ -442,80 +442,5 @@
 
     CALL trace_start("compute_advect_horiz")
-
-#if 1
-
 #include "../kernels/advect_horiz.k90"
-
-#else
-    ! evaluate tracer field at point cc using piecewise linear reconstruction
-    ! q(cc)= q0 + gradq.(cc-xyz_i)  with xi centroid of hexagon
-    ! ne*hfluxt>0 iff outgoing
-    DO l = ll_begin,ll_end
-
-!DIR$ SIMD
-      DO ij=ij_begin_ext,ij_end_ext
-
-             IF (ne(ij,right)*hfluxt(ij+u_right,l)>0) THEN 
-                ed = cc(ij+u_right,l,:) - xyz_i(ij,:)
-!                qe = qi(ij,l)+sum2(gradq3d(ij,l,:),ed) 
-                 qe = qi(ij,l)+gradq3d(ij,l,1)*ed(1)+gradq3d(ij,l,2)*ed(2)+gradq3d(ij,l,3)*ed(3) 
-             ELSE
-                ed = cc(ij+u_right,l,:) - xyz_i(ij+t_right,:)
-!                qe = qi(ij+t_right,l)+sum2(gradq3d(ij+t_right,l,:),ed) 
-                qe = qi(ij+t_right,l) + gradq3d(ij+t_right,l,1)*ed(1)+gradq3d(ij+t_right,l,2)*ed(2)+gradq3d(ij+t_right,l,3)*ed(3) 
-             ENDIF
-             qflux(ij+u_right,l) = hfluxt(ij+u_right,l)*qe
-             
-             IF (ne(ij,lup)*hfluxt(ij+u_lup,l)>0) THEN 
-                ed = cc(ij+u_lup,l,:) - xyz_i(ij,:)
-!                qe = qi(ij,l)+sum2(gradq3d(ij,l,:),ed)
-                qe = qi(ij,l)  + gradq3d(ij,l,1)*ed(1)+gradq3d(ij,l,2)*ed(2)+gradq3d(ij,l,3)*ed(3) 
-             ELSE
-                ed = cc(ij+u_lup,l,:) - xyz_i(ij+t_lup,:)
-!                qe = qi(ij+t_lup,l)+sum2(gradq3d(ij+t_lup,l,:),ed) 
-                qe = qi(ij+t_lup,l) + gradq3d(ij+t_lup,l,1)*ed(1)+gradq3d(ij+t_lup,l,2)*ed(2)+gradq3d(ij+t_lup,l,3)*ed(3) 
-             ENDIF
-             qflux(ij+u_lup,l) = hfluxt(ij+u_lup,l)*qe 
-
-             IF (ne(ij,ldown)*hfluxt(ij+u_ldown,l)>0) THEN 
-                ed = cc(ij+u_ldown,l,:) - xyz_i(ij,:)
-!                qe = qi(ij,l)+sum2(gradq3d(ij,l,:),ed) 
-                qe = qi(ij,l) + gradq3d(ij,l,1)*ed(1)+gradq3d(ij,l,2)*ed(2)+gradq3d(ij,l,3)*ed(3) 
-             ELSE
-                ed = cc(ij+u_ldown,l,:) - xyz_i(ij+t_ldown,:)
-!                qe = qi(ij+t_ldown,l)+sum2(gradq3d(ij+t_ldown,l,:),ed) 
-                qe = qi(ij+t_ldown,l)+gradq3d(ij+t_ldown,l,1)*ed(1)+gradq3d(ij+t_ldown,l,2)*ed(2)+gradq3d(ij+t_ldown,l,3)*ed(3) 
-             ENDIF
-             qflux(ij+u_ldown,l) = hfluxt(ij+u_ldown,l)*qe
-       END DO
-    END DO
-
-    ! update q and, if update_mass, update mass
-    DO l = ll_begin,ll_end
-!DIR$ SIMD
-      DO ij=ij_begin,ij_end
-             ! sign convention as Ringler et al. (2010) eq. 21
-             dmass =   hfluxt(ij+u_right,l)*ne(ij,right)   &
-                     + hfluxt(ij+u_lup,l)  *ne(ij,lup)     &
-                     + hfluxt(ij+u_ldown,l)*ne(ij,ldown)   &
-                     + hfluxt(ij+u_rup,l)  *ne(ij,rup)     &
-                     + hfluxt(ij+u_left,l) *ne(ij,left)    &
-                     + hfluxt(ij+u_rdown,l)*ne(ij,rdown)
-
-             dq    =   qflux(ij+u_right,l) *ne(ij,right)   &
-                     + qflux(ij+u_lup,l)   *ne(ij,lup)     &
-                     + qflux(ij+u_ldown,l) *ne(ij,ldown)   &
-                     + qflux(ij+u_rup,l)   *ne(ij,rup)     &
-                     + qflux(ij+u_left,l)  *ne(ij,left)    &
-                     + qflux(ij+u_rdown,l) *ne(ij,rdown)
-
-             
-             newmass = mass(ij,l) - dmass/Ai(ij)
-             qi(ij,l) = (qi(ij,l)*mass(ij,l) - dq/Ai(ij) ) / newmass
-             IF(update_mass) mass(ij,l) = newmass
-
-       END DO
-    END DO
-#endif
     CALL trace_end("compute_advect_horiz")
   CONTAINS